var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  MappingProxy: () => MappingProxy,
  ObserverArray: () => ObserverArray,
  ProxyContext: () => ProxyContext,
  ProxyProvider: () => ProxyProvider,
  PxthMap: () => PxthMap,
  StockContext: () => StockContext,
  StockProxy: () => StockProxy,
  StockRoot: () => StockRoot,
  intercept: () => intercept,
  useAllStockValues: () => useAllStockValues,
  useMappingProxy: () => useMappingProxy,
  useObservers: () => useObservers,
  useStock: () => useStock,
  useStockContext: () => useStockContext,
  useStockState: () => useStockState,
  useStockValue: () => useStockValue
});
module.exports = __toCommonJS(src_exports);

// src/hooks/useStock.ts
var import_react4 = require("react");
var import_cloneDeep = __toESM(require("lodash/cloneDeep"));
var import_isFunction = __toESM(require("lodash/isFunction"));
var import_pxth4 = require("pxth");

// src/hooks/useDebugStock.ts
var import_react = require("react");
var import_pxth = require("pxth");
var stockIndex = -1;
var useDebugStock = /* @__PURE__ */ __name((stock) => {
  (0, import_react.useEffect)(() => {
    if (window.__STOCKED_DEVTOOLS_HOOK) {
      const currentStockId = ++stockIndex;
      window.__STOCKED_DEVTOOLS_HOOK.raiseEvent("new" /* NEW */, {
        data: stock.getValues(),
        id: currentStockId
      });
      return stock.watchBatchUpdates(
        (data) => window.__STOCKED_DEVTOOLS_HOOK.raiseEvent("update" /* BATCH_UPDATE */, {
          data: __spreadProps(__spreadValues({}, data), {
            origin: (0, import_pxth.getPxthSegments)(data.origin)
          }),
          id: currentStockId
        })
      );
    }
    return () => {
    };
  }, [stock]);
}, "useDebugStock");

// src/hooks/useObservers.ts
var import_react3 = require("react");
var import_pxth3 = require("pxth");
var import_tiny_invariant2 = __toESM(require("tiny-invariant"));

// src/utils/hashPxth.ts
var import_pxth2 = require("pxth");
var hashPxth = /* @__PURE__ */ __name((pxth) => JSON.stringify((0, import_pxth2.getPxthSegments)(pxth)), "hashPxth");

// src/typings/PxthMap.ts
var PxthMap = class {
  constructor() {
    this._values = {};
    this._keys = {};
    this.get = /* @__PURE__ */ __name((key) => {
      return this._values[hashPxth(key)];
    }, "get");
    this.set = /* @__PURE__ */ __name((key, value) => {
      const stingifiedKey = hashPxth(key);
      this._values[stingifiedKey] = value;
      this._keys[stingifiedKey] = key;
    }, "set");
    this.remove = /* @__PURE__ */ __name((key) => {
      const stingifiedKey = hashPxth(key);
      delete this._values[stingifiedKey];
      delete this._keys[stingifiedKey];
    }, "remove");
    this.has = /* @__PURE__ */ __name((key) => {
      return hashPxth(key) in this._values;
    }, "has");
    this.keys = /* @__PURE__ */ __name(() => Object.values(this._keys), "keys");
    this.entries = /* @__PURE__ */ __name(() => Object.entries(this._keys).map(([key, value]) => [value, this._values[key]]), "entries");
  }
};
__name(PxthMap, "PxthMap");

// src/utils/ObserverArray.ts
var import_tiny_invariant = __toESM(require("tiny-invariant"));
var ObserverArray = class {
  constructor() {
    this.observers = {};
    this.counter = 0;
    this.isEmpty = /* @__PURE__ */ __name(() => Object.values(this.observers).length === 0, "isEmpty");
  }
  call(message) {
    Object.values(this.observers).forEach((observer) => observer(message));
  }
  add(observer) {
    const key = this.counter++;
    this.observers[key] = observer;
    return key;
  }
  remove(key) {
    (0, import_tiny_invariant.default)(
      Object.prototype.hasOwnProperty.call(this.observers, key),
      `Could not remove observer: observer with key ${key} not exists`
    );
    delete this.observers[key];
  }
};
__name(ObserverArray, "ObserverArray");

// src/utils/useLazyRef.ts
var import_react2 = require("react");
var useLazyRef = /* @__PURE__ */ __name((initializer) => {
  const ref = (0, import_react2.useRef)(null);
  if (ref.current === null) {
    ref.current = initializer();
  }
  return ref;
}, "useLazyRef");

// src/hooks/useObservers.ts
var useObservers = /* @__PURE__ */ __name(() => {
  const observersMap = (0, import_react3.useRef)(new PxthMap());
  const batchUpdateObservers = useLazyRef(() => new ObserverArray());
  const batchUpdate = (0, import_react3.useCallback)(
    (update) => {
      batchUpdateObservers.current.call(update);
    },
    [batchUpdateObservers]
  );
  const observeBatchUpdates = (0, import_react3.useCallback)(
    (observer) => batchUpdateObservers.current.add(observer),
    [batchUpdateObservers]
  );
  const stopObservingBatchUpdates = (0, import_react3.useCallback)(
    (key) => batchUpdateObservers.current.remove(key),
    [batchUpdateObservers]
  );
  const observe = (0, import_react3.useCallback)((path, observer) => {
    if (!observersMap.current.has(path)) {
      observersMap.current.set(path, new ObserverArray());
    }
    return observersMap.current.get(path).add(observer);
  }, []);
  const stopObserving = (0, import_react3.useCallback)((path, observerKey) => {
    const currentObservers = observersMap.current.get(path);
    (0, import_tiny_invariant2.default)(currentObservers, "Cannot remove observer from value, which is not observing");
    currentObservers.remove(observerKey);
    if (currentObservers.isEmpty()) {
      observersMap.current.remove(path);
    }
  }, []);
  const watch = (0, import_react3.useCallback)(
    (path, observer) => {
      const key = observe(path, observer);
      return () => stopObserving(path, key);
    },
    [observe, stopObserving]
  );
  const watchAll = (0, import_react3.useCallback)((observer) => watch((0, import_pxth3.createPxth)([]), observer), [watch]);
  const watchBatchUpdates = (0, import_react3.useCallback)(
    (observer) => {
      const key = observeBatchUpdates(observer);
      return () => stopObservingBatchUpdates(key);
    },
    [observeBatchUpdates, stopObservingBatchUpdates]
  );
  const isObserved = (0, import_react3.useCallback)((path) => observersMap.current.has(path), []);
  const notifyPaths = (0, import_react3.useCallback)(
    (origin, paths, values) => {
      batchUpdate({ paths, origin, values });
      paths.forEach((path) => {
        const observer = observersMap.current.get(path);
        const subValue = (0, import_pxth3.deepGet)(values, path);
        observer.call(subValue);
      });
    },
    [batchUpdate]
  );
  const notifySubTree = (0, import_react3.useCallback)(
    (path, values) => {
      const subPaths = observersMap.current.keys().filter(
        (tempPath) => (0, import_pxth3.isInnerPxth)(path, tempPath) || (0, import_pxth3.samePxth)(path, tempPath) || (0, import_pxth3.isInnerPxth)(tempPath, path)
      );
      notifyPaths(path, subPaths, values);
    },
    [notifyPaths]
  );
  const notifyAll = (0, import_react3.useCallback)(
    (values) => notifyPaths((0, import_pxth3.createPxth)([]), observersMap.current.keys(), values),
    [notifyPaths]
  );
  return {
    watch,
    watchAll,
    watchBatchUpdates,
    isObserved,
    notifySubTree,
    notifyAll
  };
}, "useObservers");

// src/hooks/useStock.ts
var useStock = /* @__PURE__ */ __name(({ initialValues, debugName }) => {
  const values = useLazyRef(() => (0, import_cloneDeep.default)(initialValues));
  const { notifySubTree, notifyAll, watch, watchAll, watchBatchUpdates, isObserved } = useObservers();
  const setValue = (0, import_react4.useCallback)(
    (path, action) => {
      const value = (0, import_isFunction.default)(action) ? action((0, import_pxth4.deepGet)(values.current, path)) : action;
      values.current = (0, import_pxth4.deepSet)(values.current, path, value);
      notifySubTree(path, values.current);
    },
    [values, notifySubTree]
  );
  const setValues = (0, import_react4.useCallback)(
    (newValues) => {
      values.current = newValues;
      notifyAll(newValues);
    },
    [values, notifyAll]
  );
  const getValue = (0, import_react4.useCallback)((path) => (0, import_pxth4.deepGet)(values.current, path), [values]);
  const getValues = (0, import_react4.useCallback)(() => values.current, [values]);
  const resetValues = (0, import_react4.useCallback)(() => setValues((0, import_cloneDeep.default)(initialValues)), [initialValues, setValues]);
  const stock = (0, import_react4.useMemo)(
    () => ({
      getValue,
      getValues,
      setValue,
      setValues,
      resetValues,
      watch,
      watchAll,
      watchBatchUpdates,
      isObserved,
      debugName,
      paths: (0, import_pxth4.createPxth)([])
    }),
    [
      getValue,
      getValues,
      debugName,
      setValue,
      setValues,
      resetValues,
      watch,
      watchAll,
      watchBatchUpdates,
      isObserved
    ]
  );
  useDebugStock(stock);
  return stock;
}, "useStock");

// src/hooks/useStockContext.ts
var import_react10 = require("react");
var import_tiny_invariant4 = __toESM(require("tiny-invariant"));

// src/components/StockContext.ts
var import_react5 = require("react");
var StockContext = (0, import_react5.createContext)(void 0);

// src/components/StockRoot.tsx
var import_react6 = __toESM(require("react"));
var StockRoot = /* @__PURE__ */ __name((_a) => {
  var _b = _a, { children } = _b, stockConfig = __objRest(_b, ["children"]);
  const stock = useStock(stockConfig);
  return /* @__PURE__ */ import_react6.default.createElement(StockContext.Provider, {
    value: stock
  }, children);
}, "StockRoot");

// src/components/ProxyContext.ts
var import_react7 = require("react");
var ProxyContext = (0, import_react7.createContext)(void 0);

// src/components/ProxyProvider.tsx
var import_react8 = __toESM(require("react"));
var ProxyProvider = /* @__PURE__ */ __name(({ proxy, children }) => {
  const stock = useStockContext();
  return /* @__PURE__ */ import_react8.default.createElement(StockContext.Provider, {
    value: stock
  }, /* @__PURE__ */ import_react8.default.createElement(ProxyContext.Provider, {
    value: proxy
  }, typeof children === "function" ? children(proxy.path) : children));
}, "ProxyProvider");

// src/utils/useInterceptors.ts
var import_react9 = require("react");
var import_cloneDeep2 = __toESM(require("lodash/cloneDeep"));
var import_isFunction2 = __toESM(require("lodash/isFunction"));
var import_unset = __toESM(require("lodash/unset"));
var import_pxth5 = require("pxth");
var import_tiny_invariant3 = __toESM(require("tiny-invariant"));
var shouldUseProxy = /* @__PURE__ */ __name((proxy, path) => proxy && ((0, import_pxth5.isInnerPxth)(proxy.path, path) || (0, import_pxth5.samePxth)(proxy.path, path)), "shouldUseProxy");
var intercept = /* @__PURE__ */ __name((proxy, path, standardCallback, proxiedCallback, args) => {
  if (!shouldUseProxy(proxy, path)) {
    return standardCallback(...args);
  } else {
    return proxiedCallback(...args);
  }
}, "intercept");
var useInterceptors = /* @__PURE__ */ __name((stock, proxy) => {
  const { watch, setValue, getValue, setValues, getValues } = stock;
  (0, import_react9.useEffect)(
    () => (0, import_tiny_invariant3.default)(
      !proxy || proxy.isActive(),
      "Cannot use not activated proxy. Maybe you forgot to call proxy.activate()?"
    ),
    [proxy]
  );
  const interceptedWatch = (0, import_react9.useCallback)(
    (path, observer) => intercept(
      proxy,
      path,
      watch,
      (path2, observer2) => proxy.watch(path2, observer2, watch),
      [path, observer]
    ),
    [watch, proxy]
  );
  const interceptedSetValue = (0, import_react9.useCallback)(
    (path, value) => intercept(
      proxy,
      path,
      setValue,
      (path2, value2) => proxy.setValue(path2, value2, setValue, getValue),
      [path, value]
    ),
    [getValue, proxy, setValue]
  );
  const interceptedGetValue = (0, import_react9.useCallback)(
    (path) => intercept(proxy, path, getValue, (path2) => proxy.getValue(path2, getValue), [
      path
    ]),
    [proxy, getValue]
  );
  const interceptedGetValues = (0, import_react9.useCallback)(() => {
    let allValues = (0, import_cloneDeep2.default)(getValues());
    const proxiedValue = proxy.getValue(proxy.path, getValue);
    allValues = (0, import_pxth5.deepSet)(allValues, proxy.path, proxiedValue);
    return allValues;
  }, [proxy, getValues, getValue]);
  const interceptedSetValues = (0, import_react9.useCallback)(
    (values) => {
      const proxiedValue = (0, import_pxth5.deepGet)(values, proxy.path);
      (0, import_unset.default)(values, (0, import_pxth5.getPxthSegments)(proxy.path));
      proxy.setValue(
        proxy.path,
        proxiedValue,
        (path, value) => {
          values = (0, import_pxth5.deepSet)(values, path, (0, import_isFunction2.default)(value) ? value((0, import_pxth5.deepGet)(values, path)) : value);
        },
        getValue
      );
      setValues(values);
    },
    [getValue, proxy, setValues]
  );
  if (!proxy) {
    return stock;
  }
  return __spreadProps(__spreadValues({}, stock), {
    watch: interceptedWatch,
    setValue: interceptedSetValue,
    getValue: interceptedGetValue,
    getValues: interceptedGetValues,
    setValues: interceptedSetValues
  });
}, "useInterceptors");

// src/hooks/useStockContext.ts
var useStockContext = /* @__PURE__ */ __name((stock, proxy) => {
  const contextStock = (0, import_react10.useContext)(StockContext);
  const contextProxy = (0, import_react10.useContext)(ProxyContext);
  stock = stock != null ? stock : contextStock;
  proxy = proxy != null ? proxy : contextProxy;
  (0, import_tiny_invariant4.default)(stock, "You're trying to access stock outside StockContext and without providing custom stock.");
  return useInterceptors(stock, proxy);
}, "useStockContext");

// src/hooks/useStockValue.ts
var import_react11 = require("react");
var useStockValue = /* @__PURE__ */ __name((path, customStock, proxy) => {
  const stock = useStockContext(customStock, proxy);
  const { watch, getValue } = stock;
  const [, forceUpdate] = (0, import_react11.useReducer)((val) => val + 1, 0);
  const value = useLazyRef(() => getValue(path));
  (0, import_react11.useEffect)(
    () => watch(path, (newValue) => {
      value.current = newValue;
      forceUpdate();
    }),
    [path, watch, value]
  );
  return value.current;
}, "useStockValue");

// src/hooks/useStockState.ts
var import_react12 = require("react");
var useStockState = /* @__PURE__ */ __name((path, customStock, proxy) => {
  const stock = useStockContext(customStock, proxy);
  const value = useStockValue(path, customStock, proxy);
  const { setValue } = stock;
  const set = (0, import_react12.useCallback)((action) => setValue(path, action), [path, setValue]);
  return [value, set];
}, "useStockState");

// src/hooks/useAllStockValues.ts
var import_pxth6 = require("pxth");
var rootPxth = (0, import_pxth6.createPxth)([]);
var useAllStockValues = /* @__PURE__ */ __name((customStock, proxy) => {
  return useStockValue(rootPxth, customStock, proxy);
}, "useAllStockValues");

// src/hooks/useMappingProxy.ts
var import_react13 = require("react");

// src/typings/MappingProxy.ts
var import_isFunction3 = __toESM(require("lodash/isFunction"));
var import_isNil = __toESM(require("lodash/isNil"));
var import_pxth9 = require("pxth");
var import_tiny_invariant6 = __toESM(require("tiny-invariant"));

// src/typings/StockProxy.ts
var StockProxy = class {
  constructor(path) {
    this.activate = /* @__PURE__ */ __name(() => Object.freeze(this), "activate");
    this.isActive = /* @__PURE__ */ __name(() => Object.isFrozen(this), "isActive");
    this.path = path;
  }
};
__name(StockProxy, "StockProxy");

// src/utils/createProxyMap.ts
var import_pxth7 = require("pxth");
var import_tiny_invariant5 = __toESM(require("tiny-invariant"));
var getAllObjectKeys = /* @__PURE__ */ __name((obj) => {
  if (Array.isArray(obj)) {
    return Object.keys(obj);
  }
  return [...Object.getOwnPropertyNames(obj), ...Object.getOwnPropertySymbols(obj)];
}, "getAllObjectKeys");
var createProxyMap = /* @__PURE__ */ __name((mapSource) => {
  const proxyMap = new PxthMap();
  if ((0, import_pxth7.isPxth)(mapSource)) {
    proxyMap.set((0, import_pxth7.createPxth)([]), mapSource);
    return proxyMap;
  }
  const queue = [[(0, import_pxth7.createPxth)([]), mapSource]];
  while (queue.length) {
    const [pathToObject, innerObject] = queue.shift();
    for (const key of getAllObjectKeys(innerObject)) {
      const item = innerObject[key];
      const pathToItem = (0, import_pxth7.joinPxths)(pathToObject, (0, import_pxth7.createPxth)([key]));
      if ((0, import_pxth7.isPxth)(item)) {
        proxyMap.set(pathToItem, item);
      } else if (typeof item === "object" && item !== null) {
        queue.push([pathToItem, item]);
      } else {
        (0, import_tiny_invariant5.default)(false, "Invalid proxy map passed.");
      }
    }
  }
  return proxyMap;
}, "createProxyMap");

// src/utils/mappingProxyUtils.ts
var import_pxth8 = require("pxth");
var getInnerPaths = /* @__PURE__ */ __name((path, proxyMap) => {
  return proxyMap.entries().filter(([to]) => {
    return (0, import_pxth8.isInnerPxth)(path, to) || (0, import_pxth8.samePxth)(path, to);
  });
}, "getInnerPaths");
var hasMappedParentPaths = /* @__PURE__ */ __name((path, proxyMap) => {
  return proxyMap.entries().some(([mappedPath]) => (0, import_pxth8.isInnerPxth)(mappedPath, path));
}, "hasMappedParentPaths");

// src/typings/MappingProxy.ts
var MappingProxy = class extends StockProxy {
  constructor(mapSource, path) {
    super(path);
    this.setValue = /* @__PURE__ */ __name((path, value, defaultSetValue, defaultGetValue) => {
      const relativeValuePath = (0, import_pxth9.relativePxth)(this.path, path);
      const normalPath = this.getNormalPath(path);
      if (hasMappedParentPaths(relativeValuePath, this.proxyMap)) {
        defaultSetValue(normalPath, value);
        return;
      }
      const innerPaths = getInnerPaths(relativeValuePath, this.proxyMap);
      const oldValue = defaultGetValue(normalPath);
      innerPaths.forEach(
        ([to, from]) => from !== void 0 && defaultSetValue(
          from,
          (0, import_pxth9.deepGet)((0, import_isFunction3.default)(value) ? value(oldValue) : value, (0, import_pxth9.relativePxth)(relativeValuePath, to))
        )
      );
    }, "setValue");
    this.watch = /* @__PURE__ */ __name((path, observer, defaultWatch) => {
      const normalPath = this.getNormalPath(path);
      return defaultWatch(normalPath, (value) => observer(this.mapValue(value, path, normalPath)));
    }, "watch");
    this.getValue = /* @__PURE__ */ __name((path, defaultGetValue) => {
      const normalPath = this.getNormalPath(path);
      return this.mapValue(defaultGetValue(normalPath), path, normalPath);
    }, "getValue");
    this.mapValue = /* @__PURE__ */ __name((value, path, normalPath) => {
      path = (0, import_pxth9.relativePxth)(this.path, path);
      if (hasMappedParentPaths(path, this.proxyMap)) {
        return value;
      }
      const innerPaths = getInnerPaths(path, this.proxyMap);
      return innerPaths.reduce(
        (acc, [to, from]) => (0, import_pxth9.deepSet)(
          acc,
          (0, import_pxth9.relativePxth)(path, to),
          (0, import_pxth9.deepGet)(value, (0, import_pxth9.relativePxth)(normalPath, from))
        ),
        {}
      );
    }, "mapValue");
    this.getProxiedPath = /* @__PURE__ */ __name((path) => {
      var _a;
      const normalPath = (_a = this.proxyMap.entries().find(([, from]) => (0, import_pxth9.samePxth)(from, path))) == null ? void 0 : _a[0];
      (0, import_tiny_invariant6.default)(
        !(0, import_isNil.default)(normalPath),
        "Mapping proxy error: trying to get normal path of proxied path, which is not defined in proxy map"
      );
      return (0, import_pxth9.joinPxths)(this.path, normalPath);
    }, "getProxiedPath");
    this.getNormalPath = /* @__PURE__ */ __name((path) => {
      const normalPath = (0, import_pxth9.relativePxth)(this.path, path);
      const isIndependent = this.proxyMap.has(normalPath);
      if (isIndependent) {
        return this.proxyMap.get(normalPath);
      }
      const hasMappedChildrenPaths = this.proxyMap.keys().some((mappedPath) => (0, import_pxth9.isInnerPxth)(normalPath, mappedPath));
      if (hasMappedChildrenPaths) {
        return (0, import_pxth9.longestCommonPxth)(
          this.proxyMap.entries().filter(([to]) => (0, import_pxth9.isInnerPxth)(normalPath, to)).map(([, from]) => from)
        );
      }
      if (hasMappedParentPaths(normalPath, this.proxyMap)) {
        const [to, from] = this.proxyMap.entries().find(([mappedPath]) => (0, import_pxth9.isInnerPxth)(mappedPath, normalPath));
        return (0, import_pxth9.joinPxths)(from, (0, import_pxth9.relativePxth)(to, normalPath));
      }
      (0, import_tiny_invariant6.default)(false, "Mapping proxy error: trying to proxy value, which is not defined in proxy map.");
    }, "getNormalPath");
    this.proxyMap = createProxyMap(mapSource);
  }
};
__name(MappingProxy, "MappingProxy");

// src/utils/areProxyMapsEqual.ts
var import_pxth10 = require("pxth");
var areProxyMapsEqual = /* @__PURE__ */ __name((map1, map2) => {
  const proxyMap1 = createProxyMap(map1);
  const proxyMap2 = createProxyMap(map2);
  if (proxyMap1.entries().length !== proxyMap2.entries().length) {
    return false;
  }
  for (const [key, value] of proxyMap1.entries()) {
    const value2 = proxyMap2.get(key);
    if (!proxyMap2.has(key) || !(0, import_pxth10.samePxth)(value, value2)) {
      return false;
    }
  }
  return true;
}, "areProxyMapsEqual");

// src/hooks/useMappingProxy.ts
var useMapMemo = /* @__PURE__ */ __name((map) => {
  const mapRef = (0, import_react13.useRef)(map);
  (0, import_react13.useEffect)(() => {
    if (!areProxyMapsEqual(mapRef.current, map)) {
      mapRef.current = map;
    }
  }, [map]);
  return areProxyMapsEqual(mapRef.current, map) ? mapRef.current : map;
}, "useMapMemo");
var useMappingProxy = /* @__PURE__ */ __name((mapSource, path) => {
  const realMap = useMapMemo(mapSource);
  return (0, import_react13.useMemo)(() => {
    const proxy = new MappingProxy(realMap, path);
    proxy.activate();
    return proxy;
  }, [hashPxth(path), realMap]);
}, "useMappingProxy");
